require 'rainbow'

namespace :thumbnail do
  desc 'Create thumbnail to every learning object without one'
  task :create_missing, [:log] => [:environment] do |t, args|
    include Log::Logging

    args.with_defaults(:log => STDOUT)

    Log::Logging.logger = Log::DatabaseLogger.new(args.log)
    logger.level = Log::DatabaseLogger::CREATE

    logger.info ' --> Creating thumbnails'

    LearningObject.missing_thumbnail.find_each do |object|
      object.attachments.where(bundle_name: 'ORIGINAL').find_each { |a| ThumbnailGenerateWorker.perform_async(a.id) } unless object.attachments.blank?
    end

    logger.close
  end
end
